
extends Camera3D
var meshi=CubeMesh.new()
var life=0.0
var icube=0
var myprecioussticks=[]
var mypreciouscubes=[]
func _ready():
	translation=Vector3(400,0,400)
	for _i in range(0,128):
		#var ins=MeshInstance.new()
		var ins=MeshInstance3D.new()
		
		ins.mesh=meshi
		ins.translation=Vector3(0,0,-0.3)+Vector3(1.7*(randf()-0.5),randf()-0.5,(randf()-0.5)*0.01+2)*0.1
		ins.scale=Vector3(0.4,4.0,0.4)*(0.05-0.03*randf())*0.1
		ins.rotation=Vector3(randf(),randf(),randf())*2*PI
		myprecioussticks.append(ins)
		add_child(ins)

var childrenareready=false
func _process(delta):
	life+=delta
	translation+=Vector3(0,0,-1)*delta*2.0
	rotate_y(delta)
	for i in range(0,myprecioussticks.size()):
		myprecioussticks[i].translation+=Vector3(sin(life*1.2+i),sin((life+i)*1.33),sin(life*1.5-i))*0.003*delta
		myprecioussticks[i].rotation+=Vector3(sin(life*1.02+i),sin((life+i)*1.13),sin(life*0.4-i))*0.1*delta
	
	if childrenareready:
		icube+=1
		if icube>=mypreciouscubes.size(): icube=0
		mypreciouscubes[icube].translation=global_transform.origin+Vector3(1.5-randf()*3,-0.4+randf()*0.9,0.5-randf()-3.0)
		mypreciouscubes[icube].scale=Vector3(1,1,1)*randf()*0.01
		mypreciouscubes[icube].rotation=Vector3(randf(),randf(),randf())*2*PI
	else:
		childrenareready=true
		for _i in range(0,378):
			var ins=MeshInstance3D.new()
			ins.mesh=meshi
			mypreciouscubes.append(ins)
			get_parent().add_child(ins)
